<html lang="en">

<head>
    <meta charset="UTF-8">
    <title> Lesson 4 :: Task 5 </title>
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <link rel="stylesheet" href="css/normalize.css" />
    <link rel="stylesheet" href="css/style.css" />
    <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/3.4.1/css/bootstrap.min.css"
        integrity="sha384-HSMxcRTRxnN+Bdg0JdbxYKrThecOKuH5zCYotlSAcp1+c8xmyTe9GYg1l9a69psu" crossorigin="anonymous">
</head>

<body>
    <div class="container">
        <div class="row">
            <div class="col-md-8">

                <form id="form">

                    <div class="form-group">
                        <label for="name">Имя пользователя</label>
                        <input type="text" class="form-control" name="name" id="name">
                    </div>

                    <div class="form-group">
                        <label for="email">Email</label>
                        <input type="email" class="form-control" name="email" id="email">
                    </div>

                    <div class="form-group">
                        <label for="password">Password</label>
                        <input type="password" class="form-control" name="password" id="password">
                    </div>

                    <div class="form-group">
                        <label for="water">Количество выпитых стаканов воды</label>
                        <input type="number" class="form-control" name="water" id="water">
                    </div>

                    <div class="form-group">
                        <label for="thanks">Спасибо за воду</label>
                        <input type="text" class="form-control" name="thanks" id="thanks">
                    </div>

                    <div class="checkbox">
                        <label>
                            <input type="checkbox" name="agree">
                            <span>
                                Принимаю соглашение
                            </span>
                        </label>
                    </div>
                    <button type="submit" class="btn btn-default">Submit</button>

                </form>

            </div>
        </div>

    </div>



    <script>


        /*
    
            Документация:
            
            https://developer.mozilla.org/ru/docs/HTML/HTML5/Constraint_validation
            
            form.checkValidity() > Проверка всех полей формы на валидость
            form.reportValidity() > Проверяет все поля на валидность и выводит возле каждого из не прошедшего валидацию
                сообщение с ошибкой
    
            formElement.validity > Объект с параметрами валидности поля 
            formElement.setCustomValidity(message) > Метод который задаст validity.valid = false, и при попытке отправки
                сообщения выведет message в браузерный попал
    
            Классы для стилизации состояния элемента
            input:valid{}
            input:invalid{}
    
            Задание:
            Используя браузерное API для валидации форм реализовать валидацию следующей формы:
    
            - Имя пользователя: type:text -> validation: required; minlength = 2;  
                Если пустое вывести сообщение: "Как тебя зовут?!"
            - Email: type: email -> validation: required; minlength = 3; validEmail;
                Если эмейл не валидный вывести сообщение "Без этого поля мы не сможем отправить тебе счет!"
            - Пароль: type: password -> validation: required; minlength = 8; maxlength=16;
                Если пустой вывести сообщение: "Я никому не скажу, напиши минимум 8 символов";
            - Количество выпитых стаканов воды: type: number -> validation: required; minlength = 1; validNumber;
                Если количество 0 вывести эррор с сообщением "Ну хоть покушай немного... Яблочки вкусные"
            - Спасибо за воду: type: text -> validation: required; 
                Если текст !== "спасибо" вывести эррор с сообщением "Нужно сказать спасибо!" используя setCustomValidity();
            - Принимаю соглашение: type: checkbox -> validation: required;
                Если не выбран, вывести эррор с сообщением: "Не можем продолжить без этого пункта :("
    
            Внизу две кнопки:
    
            1) Обычный submit который отправит форму, если она валидна.
            2) Кнопка Validate(Проверить) которая запускает методы:
                - yourForm.checkValidity: и выводит на страницу сообщение с результатом проверки
                - yourForm.reportValidity: вызывает проверку всех правил и вывод сообщения с ошибкой, если такая есть
    
        */

        let form = document.getElementById("form")
        let name = document.getElementById("name")
        let email = document.getElementById("email")
        let password = document.getElementById("password")
        let water = document.getElementById("water")
        let thanks = document.getElementById("thanks")
        let agree = form.querySelector('.checkbox input[name="agree"]')


        name.setAttribute("required", "required")
        name.setAttribute("minlength", "2")

        // set custom error message if input is empty
        function validateEmpty(input, message) {
            input.setCustomValidity("")
            if (input.value === "") {
                input.setCustomValidity(message)
            }
        }

        email.setAttribute("required", "required")
        email.setAttribute("minlength", "3")

        function validateEmail(input) {
            input.setCustomValidity("")
            console.log(input.validity.typeMismatch)
            if (input.validity.typeMismatch && input.type === "email") {
                input.setCustomValidity("Без этого поля мы не сможем отправить тебе счет!")
            }
        }

        password.setAttribute("required", "required")
        password.setAttribute("minlength", "8")
        password.setAttribute("maxlength", "16")



        water.setAttribute("required", "required")
        water.setAttribute("minlength", "1")

        function validateZero(input, message) {
            input.setCustomValidity("")
            if (input.value === "0") {
                input.setCustomValidity(message)
            }
        }


        thanks.setAttribute("required", "required")
        thanks.setAttribute("minlength", "1")
        thanks.setCustomValidity("Нужно сказать спасибо!")

        function validateNotEqualTo(input, equalTo, message) {
            input.setCustomValidity("")
            if (input.value !== equalTo) {
                input.setCustomValidity(message)
            }
        }


        agree.setAttribute("required", "required")

        function validateCheckbox(input, message) {
            input.setCustomValidity("")
            if (input.checked === false) {
                input.setCustomValidity(message)
            }
        }

        let validateButton = document.createElement("button")
        validateButton.textContent = "Validate"
        validateButton.addEventListener("click", validateHandler)
        validateButton.classList.add("btn")
        validateButton.classList.add("btn-default")

        form.appendChild(validateButton)

        function validateElements() {
            validateEmpty(name, "Как тебя зовут?!")
            validateEmail(email)
            validateEmpty(password, "Я никому не скажу, напиши минимум 8 символов")
            validateZero(water, "Ну хоть покушай немного... Яблочки вкусные")
            validateNotEqualTo(thanks, "спасибо", "Нужно сказать спасибо!")
            validateCheckbox(agree, "Не можем продолжить без этого пункта :(")
        }

        function validateHandler(e) {
            validateElements()
            form.checkValidity()
            form.reportValidity()
        }

    </script>
</body>

</html>